
function show(node) {
    node.style.display = '';
    return node;
}

function hide(node) {
    node.style.display = 'none';
    return node;
}

function update(node, text) {
    node.appendChild(document.createTextNode(text));
    return node;
}

function clear(node) {
    while (node.hasChildNodes()) {
        node.removeChild(node.firstChild);
    }
    return node;
}

function smscoin(id) { return document.getElementById(id) }

function showsmscoin(id) { return show(smscoin(id)) }

function hidesmscoin(id) { return hide(smscoin(id)) }

function updatesmscoin(id, text) { return update(smscoin(id), text) }

function clearsmscoin(id) { return clear(smscoin(id)) }

function updateInstructions(data) {
    showsmscoin('instructions');
    update(clearsmscoin('message_text'), (data.rewrite==""?[data.prefix, SERVICE]:[data.rewrite]).join(' '));
    update(clearsmscoin('shortcode'), data.number);
    update(clearsmscoin('message_cost'), [data.price, data.currency,
        (parseInt(data.vat)?INCLUDING_VAT:WITHOUT_VAT)].join(' '));
    if (data.special) show(update(clearsmscoin('notes'), data.special));
    else hide(clearsmscoin('notes'));
}

function selectProvider(i) {
    if (i == '-') {
        hidesmscoin('instructions');
        return;
    }
    updateInstructions(DATA.providers[i]);
}

function selectCountry(i) {

    if (i == '-') {
        hidesmscoin('providers');
        hidesmscoin('instructions');
        return;
    }
    if (JSONResponse[i].providers && JSONResponse[i].providers.length) {
        hidesmscoin('instructions');
        showsmscoin('providers');
        DATA = JSONResponse[i];
        var select_provider = clearsmscoin('select_provider');
        var def = document.createElement('option');
        update(def, SELECT_PROVIDER).value = '-';
        select_provider.appendChild(def);
        for (var j = 0; j < DATA.providers.length; ++j) {
            var opt = document.createElement('option');
            update(opt, DATA.providers[j].name).value = j;
            select_provider.appendChild(opt);
        }
        select_provider.onchange = function() {
            selectProvider(this.value);
        }
    }
    else {
        hidesmscoin('providers');
        updateInstructions(JSONResponse[i]);
    }
}

function JSONHandleResponse() {
    //document.body.style.backgroundImage = 'none';
    if (!window.JSONResponse) {
        showsmscoin('fail');
        return;
    }
    showsmscoin('ui');
    var select_country = smscoin('select_country');
    for (var i = 0; i < JSONResponse.length; ++i) {
        var opt = document.createElement('option');
        update(opt, JSONResponse[i].country_name).value = i;
        select_country.appendChild(opt);
    }
    select_country.onchange = function() {
        selectCountry(this.value);
    }
}

function JSONSendRequest() {
    var head_node = document.getElementsByTagName('head').item(0);
    var js_node = document.createElement('script');
    js_node.src = window.JSON_URL;
    js_node.type = 'text/javascript';
    js_node.charset = 'utf-8';
    if (navigator.product == 'Gecko' || navigator.userAgent.indexOf('Opera') != -1) {
        js_node.onload = JSONHandleResponse;
    }
    else {
        js_node.onreadystatechange = function(evt) {
            evt? 1: evt = window.event;
            var rs = (evt.target || evt.srcElement).readyState;
            if (rs == 'loaded' || rs == 'complete') {
                JSONHandleResponse();
            }
        }
    }
    head_node.appendChild(js_node);
}
if (window.addEventListener) {
    window.addEventListener('load', JSONSendRequest, false);
}
else if (window.attachEvent) {
    window.attachEvent('onload', JSONSendRequest);
}
